# -*- coding: utf-8 -*-
import os

class attachment(object):
	
	def __init__(self,bufferobj,bytesize=None,headers={},header_encoding='UTF-8'):
		"""
		attachment objects consist of a binary file-like buffer object and a header
		dict. The 
		"""
		from ladon.compat import PORTABLE_BYTES
		self.headers = {}
		self.size = bytesize
		for k,v in headers.items():
			if isinstance(k, PORTABLE_BYTES):
				k = k.decode(header_encoding)
			if isinstance(v, PORTABLE_BYTES):
				v = v.decode(header_encoding)
			self.headers[k] = v
		self.bufferobj = bufferobj
		self.read = self.bufferobj.read
		self.readline = self.bufferobj.readline
		self.readlines = self.bufferobj.readlines
		self.close = self.bufferobj.close

	def __del__(self):
		if self.bufferobj:
			self.bufferobj.close()

	def header(self,name):
		if name in self.headers:
			return self.headers[name]
		else:
			return None
	
	def headers(self):
		return self.headers
